#!/usr/bin/python
import sys
import os
import re
import cPickle
import google

def score(term):
	#the import and .LICENSE_KEY lines must be done only once, but for the
	#sake of completeness, I will include them here for this example.
	
	google.LICENSE_KEY = "gZxx8CJQFHIujX0ulxIetgxz1boskYwU" #You can get a key at http://www.google.com/api.
							#we should probably get one just for this
							#project
	data = google.doGoogleSearch(term)
	edu = 0
	com = 0
	for result in data.results:
		domain = result.URL.split("/")[2]
		#For "http://www.test.com/blah/blah", the split returns:
		#["http:", "", "www.test.com", "blah", "blah"], so we're getting
		#the "www.test.com"

		tld = domain[-3:] #will return "edu" or "com"
		if tld == "edu":
			edu += 1
		elif tld == "com":
			com += 1

	score = pow(2, edu) - pow(1.3, com)
	return score

if __name__ == "__main__":
	path = 'elimList'
	file = open(path, 'rb')
	common = cPickle.load(file)
	file.close()
	path = 'words.txt'
	file = open(path,'rb')
	words = cPickle.load(file)
	file.close()
	#words = ['CS', 'Front', 'Page', 'A', 'program', 'that', 'would', 'crawl', 'the', 'department', 'web', 'page', 'and', 'create', 'a', 'news', 'summary', 'like', 'of', 'Google', 'News', '(news.google.com).', 'Goals:', 'It', 'be', 'allow', 'one', 'to', 'keep', 'track', 'activity.', 'provide', 'useful', 'information', 'for', 'both', 'current', 'students', 'in', 'prospective', 'hoping', 'learn', 'more', 'about', 'department.', 'give', 'interesting', 'ongoing', 'projects', 'exposure.', 'spotlight', 'up-and-coming', 'currents', 'within', 'community.', 'could', 'statistics,', 'such', 'as', 'involvement', 'various', 'professors', 'activities.', 'benefit', 'us', 'by', 'developing', 'our', 'understanding', 'giving', 'better', 'foundation', 'machine', 'learning.', 'Implementation', 'We', 'will:', 'Utilize', 'Perl', 'CGI', 'standards', 'compliant', 'website.', 'Use', 'Python', 'crawler.', 'clustering', 'learning', 'well', 'natural', 'language', 'processing.', 'To', 'rank', 'popular', 'terms,', 'we', 'list', 'all', 'words', 'websites', 'use', 'dictionary', 'filter', 'out', 'common', 'words.', 'Then', 'perform', 'search', 'on', 'terms', 'them', 'number', 'times', 'they', 'show', 'up', 'end', 'with', '"edu".', 'feel', 'this', 'will', 'good', 'initial', 'metric', 'which', 'determine', '"scholarly', 'nature"', 'term.', 'When', 'displaying', 'websites,', 'instead', 'an', 'abstract', 'first', 'few', 'sentences', 'website,', 'display', 'have', 'high', 'concentration', 'ranked', 'above.']
	toRemove = []
	#for word in words.keys():
	for word in words:
		if word in common or len(word)<=1:
			#words.remove(word)
			toRemove.append(word)
	for word in toRemove:
		del words[word]
	#print words		
	
	#This just does a count of the most frequent words
	count = []
	min = 0
	print words["distortions"]
	
	for word in words.keys():
		if len(count) == 0:
			t = (word,words[word][0])
			count.append(t)
			min=words[word][0]
		else:
			if len(count) <200:
				if words[word][0] <= min:
					t = (word,words[word][0])
					count.append(t)
					min=words[word][0]
				else:
					if words[word][0] > count[0][1]:
						t=(word,words[word][0])
						count.insert(0,t)
					else:
						for x in count:
							if words[word][0] > x[1]:
								t=(word,words[word][0])
								count.insert(count.index(x),t)
								break
			else:
				if words[word][0] > min:
					for x in count:
						if words[word][0] > x[1]:
							t=(word,words[word][0])
							count.insert(count.index(x),t)
							te=count[-1]
							count.remove(te)
							min=count[-1][1]
							break
	results = {}						
	for word in count:
		results[word[0]]=words[word[0]]
	outfile = open("rawcount", 'w')
	cPickle.dump(results, outfile)
	outfile.close()
	
	gCount = []
	min = 0
	for w in count:
		print "Searching on " + w[0] + "..."
		try:
			val=score(w[0])
		except:
			Print "First search attempt failed, trying again..."
			try:
				val=score(w[0])
			except:
				Print "Second search attempt failed. Defaulting to 0."
				val=0
				cd
		if len(gCount) == 0:
			t = (w[0],val)
			gCount.append(t)
			min=val
		else:
			if len(gCount) <100:
				if val <= min:
					t = (w[0],val)
					gCount.append(t)
					min=val
				else:
					if val > gCount[0][1]:
						t=(w[0],val)
						gCount.insert(0,t)
					else:
						for x in gCount:
							if val > x[1]:
								t=(w[0],val)
								gCount.insert(gCount.index(x),t)
								break
			else:
				if val > min:
					for x in gCount:
						if val > x[1]:
							t=(w[0],val)
							gCount.insert(gCount.index(x),t)
							gCount.remove(x)
							min=gCount[-1][1]
							break
	#print score("Jerry Zhu") #Test of score function
	
	print count
	print gCount

	results = {}						
	for word in gCount:
		results[word[0]]=words[word[0]]
	outfile = open("googleCount", 'w')
	cPickle.dump(results, outfile)
	outfile.close()
	
								
""" count = []
	min = 0
	for word in words.keys():
		if len(words[word][1]) > 3:
			if len(count) == 0:
				t = (word,words[word][1])
				count.append(t)
				min=words[word][1]
			else:
				if len(count) <500:
					if words[word][1] <= min:
						t = (word,words[word][1])
						count.append(t)
						min=words[word][1]
					else:
						if words[word][1] > count[0][1]:
							t=(word,words[word][1])
							count.insert(0,t)
						else:
							for x in count:
								if words[word][1] > x[1]:
									t=(word,words[word][1])
									count.insert(count.index(x),t)
									break
				else:
					if words[word][1] > min:
						for x in count:
							if words[word][1] > x[1]:
								t=(word,words[word][1])
								count.insert(count.index(x),t)
								count.remove(x)
								min=count[-1][1]
								break
							
	#zprint count
	
	results = {}						
	for word in gCount:
		results[word[0]]=words[word[0]]
	outfile = open("filterCount", 'w')
	cPickle.dump(results, outfile)
	outfile.close() """
            #else:
            #   count[word][1][path] += 1
                
    #print count
    #print words
