import sys
import os
import re
import cPickle

if __name__ == "__main__":
	filenum = int(sys.argv[1])
	count = {}
	for x in range(filenum):
		path = "%d/wordsDict" % (x,)
		print path
		try:
			size = os.stat(path)[6]
		except:
			continue
		file = open(path,'rb')
		results = cPickle.load(file)
		file.close()
		for wordkey in results:
			word = results[wordkey]
			if not wordkey in count.keys():
				count[wordkey] = []
				count[wordkey].append(0)
				count[wordkey].append({})
			count[wordkey][0] += word[0]
			for location in word[1]:
				count[wordkey][1][location] = word[1][location]
					
	print "Writing to files"
	outfile = open("words.txt", 'w')
	cPickle.dump(count, outfile)
	outfile.close()
